diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonComplexOptions.ml ./src/daemon/common/commonComplexOptions.ml
--- ./src/daemon/common/commonComplexOptions.ml	2004-08-19 09:56:51.000000000 +0200
+++ ./src/daemon/common/commonComplexOptions.ml	2004-08-23 03:02:45.798121048 +0200
@@ -33,102 +33,6 @@
 
 (*************************************************************************)
 (*                                                                       *)
-(*                         FILES                                         *)
-(*                                                                       *)
-(*************************************************************************)
-
-module FileOption = struct
-    
-    let value_to_state v =
-      match v with
-      | StringValue "Paused" -> FilePaused
-      | StringValue "Downloading" -> FileDownloading
-      | StringValue "Downloaded" -> FileDownloaded
-      | _ -> raise Not_found
-    
-    let state_to_value s = 
-      match s with
-      | FilePaused | FileAborted _ -> StringValue "Paused"
-      | FileDownloaded -> StringValue "Downloaded"
-      | _ -> StringValue "Downloading"
-    
-    
-    let value_to_file is_done v =
-      match v with
-        Options.Module assocs ->
-          let get_value name conv = conv (List.assoc name assocs) in
-          let network = try get_value "file_network" value_to_string
-            with _ -> "Donkey" in
-          let network = network_find_by_name network in
-          let file_state = 
-            try
-              get_value "file_state" value_to_state 
-            with _ -> FileDownloading
-          in          
-          let file_size = try
-              value_to_int64 (List.assoc "file_size" assocs) 
-            with _ -> Int64.zero
-          in
-          
-          let file = network_file_of_option network file_size 
-              file_state assocs in
-          let priority = try get_value "file_priority" value_to_int 
-            with _ -> 0 in
-          
-          let impl = as_file_impl file in
-          (try
-              impl.impl_file_age <- 
-                normalize_time (get_value "file_age" value_to_int)
-            with _ -> ());
-          set_file_state file file_state;       
-          (match file_state with
-              FileDownloading -> lprintf "New downloading file\n";
-            | FileDownloaded -> lprintf "New downloaded file\n";
-            | _ -> lprintf "..........\n"
-          );
-          
-          (try
-              set_file_best_name file
-              (get_value "file_filename" value_to_string)
-            with _ -> ());
-          set_file_priority file priority;
-          file
-      | _ -> assert false
-          
-    let file_to_value file =
-        let netname = string_to_value (file_network file).network_name in
-      let impl = as_file_impl file in
-      Options.Module (
-        ("file_network", netname) ::
-        ("file_size", int64_to_value (file_size file)) ::
-        ("file_priority", int_to_value (file_priority file)) ::
-        ("file_state", state_to_value (file_state file)) ::
-        ("file_filename", string_to_value (file_best_name file)) ::
-        ("file_age", IntValue (Int64.of_int impl.impl_file_age)) ::
-          (file_to_option file)
-        )
-          
-    let t is_done =
-      define_option_class "File" (value_to_file is_done) file_to_value
-    ;;
-  end
-
-
-let swarmers_section = file_section files_ini [] ""
-let files_section = file_section files_ini [] "" 
-  
-let done_files = 
-  define_option files_section ["done_files"] 
-    "The files whose download is finished" (
-    listiter_option (FileOption.t true)) []
-  
-let files = 
-  define_option files_section ["files"] 
-    "The files currently being downloaded" (
-    listiter_option (FileOption.t false)) []
-
-(*************************************************************************)
-(*                                                                       *)
 (*                         RESULTS                                       *)
 (*                                                                       *)
 (*************************************************************************)
@@ -732,15 +636,149 @@
     (list_option SharedDirectoryOption.t) 
   [
     {
-      shdir_dirname = "shared";
+      shdir_dirname = (Filename.concat file_basedir "incoming");
       shdir_priority = 0;
       shdir_networks = [];
       shdir_strategy = "all_files";
     }
   ]
 
+module SharedDirectoryIndexOption = struct
+    let index_to_shared_directory v =
+      let i = value_to_int v in
+      try 
+        List.nth !!shared_directories i
+      with Failure "nth" ->
+      try
+        List.hd !!shared_directories
+      with Failure "hd" ->
+        restore_default shared_directories;
+	List.hd !!shared_directories
+    
+    let shared_directory_to_index sh =
+      let res = ref 0 in
+      ignore (List.fold_left (fun i s ->
+        if s.shdir_dirname = sh.shdir_dirname then
+	  res := i;
+	i + 1
+      ) 0 !!shared_directories);
+      int_to_value !res
+      
+     let t =
+      define_option_class "Shared Directory Index" index_to_shared_directory
+        shared_directory_to_index
+   
+  end
+  
+let default_incoming = define_option current_section ["default_incoming" ]
+  "Shared directory where files will be commited per default"
+  SharedDirectoryIndexOption.t
+  (List.hd !!shared_directories)
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         FILES                                         *)
+(*                                                                       *)
+(*************************************************************************)
+
+module FileOption = struct
 
+    open SharedDirectoryIndexOption
+    
+    let value_to_state v =
+      match v with
+      | StringValue "Paused" -> FilePaused
+      | StringValue "Downloading" -> FileDownloading
+      | StringValue "Downloaded" -> FileDownloaded
+      | _ -> raise Not_found
+    
+    let state_to_value s = 
+      match s with
+      | FilePaused | FileAborted _ -> StringValue "Paused"
+      | FileDownloaded -> StringValue "Downloaded"
+      | _ -> StringValue "Downloading"
     
+      
+    let value_to_file is_done v =
+      match v with
+        Options.Module assocs ->
+          let get_value name conv = conv (List.assoc name assocs) in
+          let network = try get_value "file_network" value_to_string
+            with _ -> "Donkey" in
+          let network = network_find_by_name network in
+          let file_state = 
+            try
+              get_value "file_state" value_to_state 
+            with _ -> FileDownloading
+          in          
+          let file_size = try
+              value_to_int64 (List.assoc "file_size" assocs) 
+            with _ -> Int64.zero
+          in
+          
+          let file = network_file_of_option network file_size 
+              file_state assocs in
+          let priority = try get_value "file_priority" value_to_int 
+            with _ -> 0 in
+          
+          let impl = as_file_impl file in
+          (try
+              impl.impl_file_age <- 
+                normalize_time (get_value "file_age" value_to_int)
+            with _ -> ());
+          set_file_state file file_state;       
+          (match file_state with
+              FileDownloading -> lprintf "New downloading file\n";
+            | FileDownloaded -> lprintf "New downloaded file\n";
+            | _ -> lprintf "..........\n"
+          );
+          
+          (try
+              set_file_best_name file
+              (get_value "file_filename" value_to_string)
+            with _ -> ());
+          set_file_priority file priority;
+	  (try 
+	      set_file_dst_share file (Some 
+	        (get_value "file_dst_share" index_to_shared_directory))
+	   with _ -> set_file_dst_share file None);
+          file
+      | _ -> assert false
+          
+    let file_to_value file =
+        let netname = string_to_value (file_network file).network_name in
+      let impl = as_file_impl file in
+      Options.Module (
+        ("file_network", netname) ::
+        ("file_size", int64_to_value (file_size file)) ::
+        ("file_priority", int_to_value (file_priority file)) ::
+        ("file_state", state_to_value (file_state file)) ::
+        ("file_filename", string_to_value (file_best_name file)) ::
+        ("file_age", IntValue (Int64.of_int impl.impl_file_age)) ::
+	(match file_dst_share file with
+	  Some sh -> [ ("file_dst_share", shared_directory_to_index sh) ]
+	  | None  -> []) @
+        (file_to_option file)
+      )
+          
+    let t is_done =
+      define_option_class "File" (value_to_file is_done) file_to_value
+    ;;
+  end
+
+let files_section = file_section files_ini [] "" 
+let swarmers_section = file_section files_ini [] ""
+
+let done_files = 
+  define_option files_section ["done_files"] 
+    "The files whose download is finished" (
+    listiter_option (FileOption.t true)) []
+  
+let files = 
+  define_option files_section ["files"] 
+    "The files currently being downloaded" (
+    listiter_option (FileOption.t false)) []
+
 (*************************************************************************)
 (*                                                                       *)
 (*                         Functions                                     *)
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonComplexOptions.mli ./src/daemon/common/commonComplexOptions.mli
--- ./src/daemon/common/commonComplexOptions.mli	2004-08-19 09:56:51.000000000 +0200
+++ ./src/daemon/common/commonComplexOptions.mli	2004-08-23 02:51:21.090212472 +0200
@@ -36,6 +36,7 @@
 
 val shared_directories : 
   CommonTypes.shared_directory list Options.option_record
+val default_incoming : CommonTypes.shared_directory Options.option_record
 val sharing_only_directory : CommonTypes.sharing_strategy
 
 val swarmers_section : Options.options_section
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonFile.ml ./src/daemon/common/commonFile.ml
--- ./src/daemon/common/commonFile.ml	2004-08-19 09:56:51.000000000 +0200
+++ ./src/daemon/common/commonFile.ml	2004-08-23 02:51:21.092212168 +0200
@@ -49,6 +49,7 @@
     mutable impl_file_best_name : string;
     mutable impl_file_priority: int; (* normal = 0, low < 0, high > 0 *)
     mutable impl_file_last_seen : int;
+    mutable impl_file_dst_share : CommonTypes.shared_directory option;
   }
 
 
@@ -117,6 +118,7 @@
     impl_file_priority = 0;
     impl_file_last_seen = 0;
     impl_file_comment = "";
+    impl_file_dst_share = None;
   }
   
 let dummy_file = as_file dummy_file_impl  
@@ -234,6 +236,14 @@
   let impl = as_file_impl file in
   impl.impl_file_comment
       
+let file_dst_share file =
+  let file = as_file_impl file in
+  file.impl_file_dst_share
+
+let set_file_dst_share file share =
+  let file = as_file_impl file in
+  file.impl_file_dst_share <- share
+
 let file_best_name (file : file) =
   let file = as_file_impl file in
   file.impl_file_best_name
@@ -553,14 +563,17 @@
     
     end else
     begin
-      Printf.bprintf buf "[%-s %5d] %s %10s %10s\npriority %d\n" 
+      Printf.bprintf buf "[%-s %5d] %s %10s %10s\npriority %d dst-share %s\n" 
         n.network_name (file_num file) 
       (match info.G.file_names with
           [] -> Md4.to_string info.G.file_md4
         | (name,_) :: _ -> String2.shorten !!max_name_len name)
       (Int64.to_string info.G.file_size)
       (Int64.to_string info.G.file_downloaded)
-      (file_priority file);
+      (file_priority file)
+      (match file_dst_share file with
+        Some sh -> sh.shdir_dirname
+	| None	-> "<default>");
       Printf.bprintf buf "Chunks: [%-s]\n" info.G.file_chunks;
       List.iter (fun (name,_) -> Printf.bprintf buf "    (%s)\n" name) info.G.file_names
     end;
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonFile.mli ./src/daemon/common/commonFile.mli
--- ./src/daemon/common/commonFile.mli	2004-08-19 09:56:51.000000000 +0200
+++ ./src/daemon/common/commonFile.mli	2004-08-23 02:56:43.739162376 +0200
@@ -35,6 +35,7 @@
   mutable impl_file_best_name : string;
   mutable impl_file_priority : int;
   mutable impl_file_last_seen : int;
+  mutable impl_file_dst_share : CommonTypes.shared_directory option;
 } 
 and 'a file_ops = {
   mutable op_file_network : CommonTypes.network;
@@ -116,6 +117,8 @@
 val file_debug : CommonTypes.file -> string
 val set_file_comment : CommonTypes.file -> string -> unit
 val file_comment : CommonTypes.file -> string
+val file_dst_share : CommonTypes.file -> CommonTypes.shared_directory option
+val set_file_dst_share : CommonTypes.file -> CommonTypes.shared_directory option -> unit
   
 val recover_bytes : CommonTypes.file -> (int64 * int64) list
 val file_write : CommonTypes.file -> int64 -> string -> int -> int -> unit
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonInteractive.ml ./src/daemon/common/commonInteractive.ml
--- ./src/daemon/common/commonInteractive.ml	2004-08-19 09:56:51.000000000 +0200
+++ ./src/daemon/common/commonInteractive.ml	2004-08-23 02:55:47.224753872 +0200
@@ -67,10 +67,11 @@
   let best_name = file_best_name file in
   let file_name = file_disk_name file in
   let incoming_dir =
+    let share = CommonShared.share_to_commit file in
     if network.network_incoming_subdir () <> "" then
-      Filename.concat !!incoming_directory
+      Filename.concat share.shdir_dirname
         (network.network_incoming_subdir ())
-    else !!incoming_directory
+    else share.shdir_dirname
   in
   (try Unix2.safe_mkdir incoming_dir with _ -> ());
   let new_name = 
@@ -112,13 +113,13 @@
             lprintf "destroyed\n";
             let impl = as_file_impl file in
             impl.impl_file_ops.op_file_commit impl.impl_file_val new_name;
-            
+	    let share = CommonShared.share_to_commit file in
             begin
               try
                 if not (Unix2.is_directory new_name) then 
                   ignore (CommonShared.new_shared 
-                      !!incoming_directory !!incoming_directory_prio
-                      best_name new_name);
+                      share.shdir_dirname share.shdir_priority
+		      best_name new_name);
               with e ->
                   lprintf "Exception %s while trying to share commited file\n"
                     (Printexc2.to_string e);
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonOptions.ml ./src/daemon/common/commonOptions.ml
--- ./src/daemon/common/commonOptions.ml	2004-08-19 09:56:52.000000000 +0200
+++ ./src/daemon/common/commonOptions.ml	2004-08-23 02:51:21.099211104 +0200
@@ -797,16 +797,6 @@
     "The directory where temporary files should be put" 
     string_option (Filename.concat file_basedir "temp")
 
-let incoming_directory_prio =
-  define_expert_option current_section ["incoming_directory_prio" ]
-      "The upload prio of the incoming directory"
-          int_option 0
-
-let incoming_directory = 
-  define_option current_section ["incoming_directory" ] 
-    "The directory where downloaded files should be moved after commit" 
-    string_option (Filename.concat file_basedir "incoming")
-
 let default_sharing_strategy =
   define_option current_section ["default_sharing_strategy" ] 
     "Sharing strategy the share command will use when none is specified"
@@ -1510,4 +1500,4 @@
       
       options_version =:= 1
       
-  | _ -> ()
\ No newline at end of file
+  | _ -> ()
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonShared.ml ./src/daemon/common/commonShared.ml
--- ./src/daemon/common/commonShared.ml	2004-08-19 09:56:52.000000000 +0200
+++ ./src/daemon/common/commonShared.ml	2004-08-23 02:51:21.101210800 +0200
@@ -334,16 +334,14 @@
       H.iter (fun _ -> incr counter) shareds_by_num;
       Printf.bprintf buf "  shared: %d\n" !counter;
   )
-  
+
 let com_shareds_by_num = shareds_by_num
 let shareds_by_num = ()
 
-(* This won't fit nicely with priorities on upload.
-  Maybe the pririties could be given in another option,
-  and the association would remain independantly of the fact
-  that the directories are currently shared or not. *)
-  
-(*let _ = 
-  Options.set_string_wrappers shared_directories
-    Filepath.semipath_to_string
-    Filepath.string_to_semipath*)
+open CommonComplexOptions
+
+let share_to_commit file =
+  match CommonFile.file_dst_share file with
+    Some sh -> sh
+    | None  -> !!default_incoming
+
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/common/commonShared.mli ./src/daemon/common/commonShared.mli
--- ./src/daemon/common/commonShared.mli	2004-08-19 09:56:52.000000000 +0200
+++ ./src/daemon/common/commonShared.mli	2004-08-23 02:51:21.102210648 +0200
@@ -49,5 +49,5 @@
 val shared_check_files : unit -> unit
 val impl_shared_info : 'a shared_impl -> GuiTypes.shared_info
 val shared_info : CommonTypes.shared -> GuiTypes.shared_info
-
+val share_to_commit : CommonTypes.file -> CommonTypes.shared_directory
   
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/driver/driverCommands.ml ./src/daemon/driver/driverCommands.ml
--- ./src/daemon/driver/driverCommands.ml	2004-08-19 09:56:53.000000000 +0200
+++ ./src/daemon/driver/driverCommands.ml	2004-08-23 02:51:21.112209128 +0200
@@ -1305,8 +1305,7 @@
                   | 5 -> 
                       [
                         strings_of_option previewer; 
-                        strings_of_option incoming_directory; 
-                        strings_of_option incoming_directory_prio; 
+			strings_of_option default_incoming;
                         strings_of_option temp_directory; 
                         strings_of_option file_completed_cmd; 
                         strings_of_option allow_browse_share; 
@@ -1574,9 +1573,6 @@
             
             let counter = ref 0 in
             
-            Printf.bprintf buf "\\<tr class=\\\"dl-1\\\"\\>\\<td title=\\\"Incoming directory is always shared\\\" class=\\\"srb\\\"\\>Incoming\\</td\\>
-\\<td class=\\\"sr ar\\\"\\>0\\</td\\>\\<td title=\\\"Incoming\\\" class=\\\"sr\\\"\\>%s\\</td\\>\\</tr\\>" !!incoming_directory;
-            
             List.iter (fun shared_dir -> 
                 incr counter;
                 Printf.bprintf buf "\\<tr class=\\\"%s\\\"\\>
@@ -1602,7 +1598,6 @@
           begin
             
             Printf.bprintf buf "Shared directories:\n";
-            Printf.bprintf buf "  %d %s\n" !!incoming_directory_prio !!incoming_directory;
             List.iter (fun sd -> 
                 Printf.bprintf buf "  %d %s\n" 
                 sd.shdir_priority sd.shdir_dirname)
@@ -1629,7 +1624,7 @@
         
         if Unix2.is_directory arg then
           if not (List.mem shdir !!shared_directories) then begin
-              shared_directories =:= shdir :: !!shared_directories;
+              shared_directories =:= !!shared_directories @ [ shdir ];
               shared_add_directory shdir;
               "directory added"
             end (* else 
@@ -1645,18 +1640,34 @@
     
     "unshare", Arg_one (fun arg o ->
 
-        let found = ref false in
-        shared_directories =:= List.filter (fun sd ->
-            let diff = sd.shdir_dirname <> arg in
-            if not diff then found := true;
-            diff
-        ) !!shared_directories;
-        if !found then begin
+	if List.length !!shared_directories > 1 then begin
+          let found = ref false in
+          shared_directories =:= List.filter (fun sd ->
+	    if sd.shdir_dirname = arg then
+	    begin
+	      found := true;
+	      false
+	    end else
+	      true
+          ) !!shared_directories;
+
+	  if !!default_incoming.shdir_dirname = arg then
+	    default_incoming =:= List.hd !!shared_directories;
+	  
+	  List.iter (fun file ->
+	    match file_dst_share file with
+	      Some sh -> if sh.shdir_dirname = arg then
+	      		   set_file_dst_share file None
+	      | None  -> ()
+	  ) !!files;
+	  
+          if !found then begin
             CommonShared.shared_check_files ();
             _s "directory removed"
           end else
-          _s "directory already unshared"
-    
+            _s "directory already unshared"
+	end else
+	  _s "can't unshare last directory"
     ), "<dir> :\t\t\t\tshare directory <dir>";
 
     "upstats", Arg_none (fun o ->
@@ -2090,6 +2101,15 @@
         ) !!done_files;
         "Commited"
     ) , ":\t\t\t\t$bmove downloaded files to incoming directory$n";
+
+    "commit_to", Arg_multiple (fun (sh_index :: files) o ->
+	let sh = List.nth !!shared_directories (int_of_string sh_index) in
+	List.iter (fun num ->
+	  let num = int_of_string num in
+	  let file = file_find num in
+	  set_file_dst_share file (Some sh)
+	) files; ""
+    ) , "<share> <files> :\t\t\t\t$bset the shared directory where a file is commited into$n";
     
     "vd", Arg_multiple (fun args o -> 
         let buf = o.conn_buf in
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/driver/driverLink.ml ./src/daemon/driver/driverLink.ml
--- ./src/daemon/driver/driverLink.ml	2004-07-29 12:25:33.000000000 +0200
+++ ./src/daemon/driver/driverLink.ml	2004-08-23 02:51:21.113208976 +0200
@@ -49,7 +49,6 @@
 
       module CommonOptions : sig 
           
-          val incoming_directory : string Options.option_record
           val temp_directory : string Options.option_record
           val dp500_directory : string Options.option_record
           val allowed_ips : Ip.t list Options.option_record
@@ -279,9 +278,6 @@
           
           in
           
-          let mlnet_incoming_string = "MLNET INCOMING" in
-          let mlnet_incoming_string_len = String.length mlnet_incoming_string in
-          
           let mlnet_temp_string = "MLNET TEMP" in
           let mlnet_temp_string_len = String.length mlnet_temp_string in
           
@@ -290,23 +286,11 @@
             | "VIDEO" -> 
 
                 if argument = "" then begin
-                    if !!incoming_directory <> "" then
-                      write_string sock (Printf.sprintf "%s|%s|1|\r\n"
-                          mlnet_incoming_string mlnet_incoming_string
-                      );
-                    
                     if !!temp_directory <> "" then
                       write_string sock (Printf.sprintf "%s|%s|1|\r\n"
                           mlnet_temp_string mlnet_temp_string 
                       );
                     end;
-                if !!incoming_directory <> "" &&
-                  String2.starts_with argument mlnet_incoming_string then
-                    list_directory !!incoming_directory
-                      (String.sub argument mlnet_incoming_string_len
-                        (String.length argument - mlnet_incoming_string_len))
-                  
-                else
                 if !!temp_directory <> "" &&
                   String2.starts_with argument mlnet_temp_string then
                     !!temp_directory,
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/daemon/driver/driverMain.ml ./src/daemon/driver/driverMain.ml
--- ./src/daemon/driver/driverMain.ml	2004-08-19 09:56:53.000000000 +0200
+++ ./src/daemon/driver/driverMain.ml	2004-08-23 02:51:59.444381752 +0200
@@ -368,8 +368,13 @@
     
 
 (**** CREATE DIRS   ****)
+
+  if List.length !!CommonComplexOptions.shared_directories = 0 then
+  begin
+    restore_default CommonComplexOptions.shared_directories;
+    Unix2.safe_mkdir (List.hd !!CommonComplexOptions.shared_directories).shdir_dirname
+  end;
   
-  Unix2.safe_mkdir !!incoming_directory;
   Unix2.safe_mkdir "searches";
   Unix2.safe_mkdir !!temp_directory
 
@@ -442,12 +447,6 @@
   add_infinite_timer 3600. hourly_timer;
   add_infinite_timer 0.1 CommonUploads.upload_download_timer;
 
-  CommonShared.shared_add_directory {
-    shdir_dirname = !!incoming_directory;
-    shdir_priority = !!incoming_directory_prio;
-    shdir_strategy = "only_directory";
-    shdir_networks = [];
-  };
   List.iter CommonShared.shared_add_directory !!CommonComplexOptions.shared_directories;  
   
   add_infinite_timer 1800. (fun timer ->
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/gtk/gui2/gui2_options.ml ./src/gtk/gui2/gui2_options.ml
--- ./src/gtk/gui2/gui2_options.ml	2003-12-02 18:04:41.000000000 +0100
+++ ./src/gtk/gui2/gui2_options.ml	2004-08-23 02:51:21.117208368 +0200
@@ -259,7 +259,6 @@
 let mail = ref ""
 
 let temp_dir = ref ""
-let incoming_dir = ref ""
 
 let client_options_assocs = [
   "port",        client_port;
@@ -283,7 +282,6 @@
   "smtp_port", smtp_port ;
   "mail", mail ;
   "temp_directory", temp_dir ;
-  "incoming_directory", incoming_dir ;
   ]
 
 let client_options_assocs_rev = 
diff -x Root -x Repository -x Entries -x '*.rej' -x '*.orig' -u -N -r ./src/networks/bittorrent/bTInteractive.ml ./src/networks/bittorrent/bTInteractive.ml
--- ./src/networks/bittorrent/bTInteractive.ml	2004-08-19 09:56:53.000000000 +0200
+++ ./src/networks/bittorrent/bTInteractive.ml	2004-08-23 02:51:21.118208216 +0200
@@ -211,8 +211,9 @@
   let ss = filename in
   let s = File.to_string filename in  
   let file_id, torrent = BTTracker.decode_torrent s in
-  
-  let filename = Filename.concat (Filename.concat !!incoming_directory !!commit_in_subdir) torrent.torrent_name in
+
+  let incoming_directory = !!default_incoming.shdir_dirname in
+  let filename = Filename.concat (Filename.concat incoming_directory !!commit_in_subdir) torrent.torrent_name in
 
   if Sys.file_exists filename then 
     let file_u = 